"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _Formatter2 = _interopRequireDefault(require("../../formatter/Formatter"));

var _Tokenizer = _interopRequireDefault(require("../../lexer/Tokenizer"));

var _token = require("../../lexer/token");

var _bigquery = require("./bigquery.keywords");

var _bigquery2 = require("./bigquery.functions");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var reservedCommands = [// DQL, https://cloud.google.com/bigquery/docs/reference/standard-sql/query-syntax
'SELECT', 'FROM', 'WHERE', 'GROUP BY', 'HAVING', 'ORDER BY', 'QUALIFY', 'WINDOW', 'PARTITION BY', 'LIMIT', 'OFFSET', 'WITH', 'OMIT RECORD IF', // legacy
// DML, https://cloud.google.com/bigquery/docs/reference/standard-sql/dml-syntax
'INSERT', 'INSERT INTO', 'VALUES', 'DELETE', 'DELETE FROM', 'TRUNCATE TABLE', 'UPDATE', 'MERGE', 'MERGE INTO', // 'USING',
// DDL, https://cloud.google.com/bigquery/docs/reference/standard-sql/data-definition-language
'CREATE SCHEMA', 'CREATE SCHEMA IF NOT EXISTS', 'DEFAULT COLLATE', 'CREATE TABLE', 'CREATE TABLE IF NOT EXISTS', 'CREATE TEMP TABLE', 'CREATE TEMP TABLE IF NOT EXISTS', 'CREATE TEMPORARY TABLE', 'CREATE TEMPORARY TABLE IF NOT EXISTS', 'CLUSTER BY', 'CREATE OR REPLACE TABLE', 'CREATE OR REPLACE TEMP TABLE', 'CREATE OR REPLACE TEMPORARY TABLE', 'FOR SYSTEM_TIME AS OF', // CREATE SNAPSHOT TABLE
'CREATE SNAPSHOT TABLE', 'CREATE SNAPSHOT TABLE IF NOT EXISTS', 'CREATE VIEW', 'CREATE VIEW IF NOT EXISTS', 'CREATE OR REPLACE VIEW', 'CREATE MATERIALIZED VIEW', 'CREATE OR REPLACE MATERIALIZED VIEW', 'CREATE MATERIALIZED VIEW IF NOT EXISTS', 'CREATE EXTERNAL TABLE', 'CREATE OR REPLACE EXTERNAL TABLE', 'CREATE EXTERNAL TABLE IF NOT EXISTS', 'WITH CONNECTION', 'WITH PARTITION COLUMNS', 'CREATE FUNCTION', 'CREATE OR REPLACE FUNCTION', 'CREATE FUNCTION IF NOT EXISTS', 'CREATE TEMP FUNCTION', 'CREATE OR REPLACE TEMP FUNCTION', 'CREATE TEMP FUNCTION IF NOT EXISTS', 'CREATE TEMPORARY FUNCTION', 'CREATE OR REPLACE TEMPORARY FUNCTION', 'CREATE TEMPORARY FUNCTION IF NOT EXISTS', 'REMOTE WITH CONNECTION', 'CREATE TABLE FUNCTION', 'CREATE OR REPLACE TABLE FUNCTION', 'CREATE TABLE FUNCTION IF NOT EXISTS', 'RETURNS TABLE', 'CREATE PROCEDURE', 'CREATE OR REPLACE PROCEDURE', 'CREATE PROCEDURE IF NOT EXISTS', 'CREATE ROW ACCESS POLICY', 'CREATE OR REPLACE ROW ACCESS POLICY', 'CREATE ROW ACCESS POLICY IF NOT EXISTS', 'GRANT TO', 'FILTER USING', 'CREATE CAPACITY', 'AS JSON', 'CREATE RESERVATION', 'CREATE ASSIGNMENT', 'CREATE SEARCH INDEX', 'CREATE SEARCH INDEX IF NOT EXISTS', 'ALTER SCHEMA', 'ALTER SCHEMA IF EXISTS', 'SET DEFAULT COLLATE', 'SET OPTIONS', 'ALTER TABLE', 'ALTER TABLE IF EXISTS', 'ADD COLUMN', 'ADD COLUMN IF NOT EXISTS', 'RENAME TO', 'DROP COLUMN', 'DROP COLUMN IF EXISTS', 'ALTER COLUMN', 'ALTER COLUMN IF EXISTS', 'DROP NOT NULL', 'SET DATA TYPE', 'ALTER VIEW', 'ALTER VIEW IF EXISTS', 'ALTER MATERIALIZED VIEW', 'ALTER MATERIALIZED VIEW IF EXISTS', 'ALTER BI_CAPACITY', 'DROP SCHEMA', 'DROP SCHEMA IF EXISTS', 'DROP TABLE', 'DROP TABLE IF EXISTS', 'DROP SNAPSHOT TABLE', 'DROP SNAPSHOT TABLE IF EXISTS', 'DROP EXTERNAL TABLE', 'DROP EXTERNAL TABLE IF EXISTS', 'DROP VIEW', 'DROP VIEW IF EXISTS', 'DROP MATERIALIZED VIEW', 'DROP MATERIALIZED VIEW IF EXISTS', 'DROP FUNCTION', 'DROP FUNCTION IF EXISTS', 'DROP TABLE FUNCTION', 'DROP TABLE FUNCTION IF EXISTS', 'DROP PROCEDURE', 'DROP PROCEDURE IF EXISTS', 'DROP ROW ACCESS POLICY', 'DROP ALL ROW ACCESS POLICIES', 'DROP CAPACITY', 'DROP CAPACITY IF EXISTS', 'DROP RESERVATION', 'DROP RESERVATION IF EXISTS', 'DROP ASSIGNMENT', 'DROP ASSIGNMENT IF EXISTS', 'DROP SEARCH INDEX', 'DROP SEARCH INDEX IF EXISTS', 'DROP', 'DROP IF EXISTS', // DCL, https://cloud.google.com/bigquery/docs/reference/standard-sql/data-control-language
'GRANT', 'REVOKE', // Script, https://cloud.google.com/bigquery/docs/reference/standard-sql/scripting
'DECLARE', 'SET', 'EXECUTE IMMEDIATE', 'LOOP', 'END LOOP', 'REPEAT', 'END REPEAT', 'WHILE', 'END WHILE', 'BREAK', 'LEAVE', 'CONTINUE', 'ITERATE', 'FOR', 'END FOR', 'BEGIN', 'BEGIN TRANSACTION', 'COMMIT TRANSACTION', 'ROLLBACK TRANSACTION', 'RAISE', 'RETURN', 'CALL', // Debug, https://cloud.google.com/bigquery/docs/reference/standard-sql/debugging-statements
'ASSERT', // Other, https://cloud.google.com/bigquery/docs/reference/standard-sql/other-statements
'EXPORT DATA'];
var reservedBinaryCommands = ['INTERSECT', 'INTERSECT ALL', 'INTERSECT DISTINCT', 'UNION', 'UNION ALL', 'UNION DISTINCT', 'EXCEPT', 'EXCEPT ALL', 'EXCEPT DISTINCT'];
var reservedJoins = ['JOIN', 'INNER JOIN', 'LEFT JOIN', 'LEFT OUTER JOIN', 'RIGHT JOIN', 'RIGHT OUTER JOIN', 'FULL JOIN', 'FULL OUTER JOIN', 'CROSS JOIN']; // https://cloud.google.com/bigquery/docs/reference/#standard-sql-reference

var BigQueryFormatter = /*#__PURE__*/function (_Formatter) {
  _inherits(BigQueryFormatter, _Formatter);

  var _super = _createSuper(BigQueryFormatter);

  function BigQueryFormatter() {
    _classCallCheck(this, BigQueryFormatter);

    return _super.apply(this, arguments);
  }

  _createClass(BigQueryFormatter, [{
    key: "tokenizer",
    value: // TODO: handle trailing comma in select clause
    function tokenizer() {
      return new _Tokenizer["default"]({
        reservedCommands: reservedCommands,
        reservedBinaryCommands: reservedBinaryCommands,
        reservedJoins: reservedJoins,
        reservedDependentClauses: ['WHEN', 'ELSE'],
        reservedKeywords: _bigquery.keywords,
        reservedFunctionNames: _bigquery2.functions,
        openParens: ['(', '['],
        closeParens: [')', ']'],
        stringTypes: [// The triple-quoted strings are listed first, so they get matched first.
        // Otherwise the first two quotes of """ will get matched as an empty "" string.
        {
          quote: '""".."""',
          prefixes: ['R', 'B', 'RB', 'BR']
        }, {
          quote: "'''..'''",
          prefixes: ['R', 'B', 'RB', 'BR']
        }, {
          quote: '""',
          prefixes: ['R', 'B', 'RB', 'BR']
        }, {
          quote: "''",
          prefixes: ['R', 'B', 'RB', 'BR']
        }],
        identTypes: ['``'],
        identChars: {
          dashes: true
        },
        positionalParams: true,
        namedParamTypes: ['@'],
        quotedParamTypes: ['@'],
        lineCommentTypes: ['--', '#'],
        operators: BigQueryFormatter.operators,
        postProcess: postProcess
      });
    }
  }]);

  return BigQueryFormatter;
}(_Formatter2["default"]);

exports["default"] = BigQueryFormatter;

_defineProperty(BigQueryFormatter, "operators", ['~', '>>', '<<', '||']);

function postProcess(tokens) {
  return detectArraySubscripts(combineParameterizedTypes(tokens));
} // Converts OFFSET token inside array from RESERVED_COMMAND to RESERVED_FUNCTION_NAME
// See: https://cloud.google.com/bigquery/docs/reference/standard-sql/functions-and-operators#array_subscript_operator


function detectArraySubscripts(tokens) {
  var prevToken = _token.EOF_TOKEN;
  return tokens.map(function (token) {
    if (token.value === 'OFFSET' && prevToken.value === '[') {
      prevToken = token;
      return _objectSpread(_objectSpread({}, token), {}, {
        type: _token.TokenType.RESERVED_FUNCTION_NAME
      });
    } else {
      prevToken = token;
      return token;
    }
  });
} // Combines multiple tokens forming a parameterized type like STRUCT<ARRAY<INT64>> into a single token


function combineParameterizedTypes(tokens) {
  var processed = [];

  for (var i = 0; i < tokens.length; i++) {
    var token = tokens[i];
    var nextToken = tokens[i + 1] || _token.EOF_TOKEN;

    if ((_token.isToken.ARRAY(token) || _token.isToken.STRUCT(token)) && nextToken.value === '<') {
      var endIndex = findClosingAngleBracketIndex(tokens, i + 1);
      var typeDefTokens = tokens.slice(i, endIndex + 1);
      processed.push({
        type: _token.TokenType.IDENTIFIER,
        value: typeDefTokens.map(formatTypeDefToken('value')).join(''),
        text: typeDefTokens.map(formatTypeDefToken('text')).join('')
      });
      i = endIndex;
    } else {
      processed.push(token);
    }
  }

  return processed;
}

var formatTypeDefToken = function formatTypeDefToken(key) {
  return function (token) {
    if (token.type === _token.TokenType.IDENTIFIER || token.type === _token.TokenType.COMMA) {
      return token[key] + ' ';
    } else {
      return token[key];
    }
  };
};

function findClosingAngleBracketIndex(tokens, startIndex) {
  var level = 0;

  for (var i = startIndex; i < tokens.length; i++) {
    var token = tokens[i];

    if (token.value === '<') {
      level++;
    } else if (token.value === '>') {
      level--;
    } else if (token.value === '>>') {
      level -= 2;
    }

    if (level === 0) {
      return i;
    }
  }

  return tokens.length - 1;
}

module.exports = exports.default;
//# sourceMappingURL=bigquery.formatter.js.map